//////////////////////////////////////////////////////////////////////
void ClusterTriangle::Init(const rPoint3& A, const rPoint3& B, const rPoint3& C)
{
  a=A;  b=B;  c=C;
  u=b-a;
  v=c-a;
  n=(u.Cross(v)).Hat();
  u_cr_v=u.Cross(v);
}

//////////////////////////////////////////////////////////////////////
struct PerIntersectionErrData {
  real				err_ransac;
  real				err_frob;
  
  unsigned char operator<=(const PerIntersectionErrData& x) { return (err_ransac<=x.err_ransac); }
};

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

// my own code -- one I downloaded didn't work!
//////////////////////////////////////////////////////////////////////
int tri_tri_intersect(
  const ClusterTriangle&	S,
  const ClusterTriangle&	T
)
{
/*
  rPoint3 T_u=T.b-T.a;		// should precompute in tri data struct
  rPoint3 T_v=T.c-T.a;
  rPoint3 T_n=(T_u.Cross(T_v)).Hat();
  rPoint3 u_cr_v=T_u.Cross(T_v);
//  rPoint3 S_n=((S.b-S.a).Cross(S.c-S.a)).Hat();
//  if (T_n.Cross(S_n).Norm()<1e-8) return 0;	// triangles almost parallel
*/

  //::: determine which side of T each vertex of S is on
  rPoint3 A=S.a-T.a;
  rPoint3 B=S.b-T.a;
  rPoint3 C=S.c-T.a;
  real A_alpha=(T.n).Dot(A);
  real B_alpha=(T.n).Dot(B);
  real C_alpha=(T.n).Dot(C);
  int A_sign=(A_alpha<0) ? -1 : 1;
  int B_sign=(B_alpha<0) ? -1 : 1;
  int C_sign=(C_alpha<0) ? -1 : 1;
  if ((A_sign==B_sign)&&(B_sign==C_sign)) return 0;	// all on same side
  //::: (*) now know 2 of the signs are equal
  if (A_sign==B_sign) {		// C is odd
    swap(A,C);			// use pointers for speed ?
  }
  else if (A_sign==C_sign) {	// B is odd
    swap(A,B);
  }
  // ...else A is odd, do nothing

/*
Transform M(C-A,T.u,T.v);
Transform invM=M.Inverse();
(invM*(A)).Dump();
(invM*(A)).Dump();
//EXIT("dkjsaf");
invM.Dump("invM");
(T.u.Cross(T.v)).Dump();
(T.v.Cross(C-A)).Dump();
((C-A).Cross(T.u)).Dump();
*/
  //::: find coords of where edges of S hit plane of T, in T-based coords
  rPoint3 AB=B-A;
  rPoint3 AC=C-A;
  rPoint3 AB_cp_A=AB.Cross(A);
  real inv_trip_prod_AB=1.0/(AB.Dot(T.u_cr_v));	// scale for inverse matrix
  real AB_beta  =   (T.v).Dot(AB_cp_A)*inv_trip_prod_AB;
  real AB_gamma = -((T.u).Dot(AB_cp_A))*inv_trip_prod_AB;
  rPoint3 AC_cp_A=AC.Cross(A);
  real inv_trip_prod_AC=1.0/(AC.Dot(T.u_cr_v));	// scale for inverse matrix
  real AC_beta  =   (T.v).Dot(AC_cp_A)*inv_trip_prod_AC;
  real AC_gamma = -((T.u).Dot(AC_cp_A))*inv_trip_prod_AC;

  //::: test if line segment formed by [S intersect T-plane] hits T
  if ((AB_beta<0)&&(AC_beta<0)) return 0;	// both hitpoints in quad II or III
  if ((AB_gamma<0)&&(AC_gamma<0)) return 0;     // both hitpoints in quad IV or III
  //::: (*) sort hitpoints by beta coord
  if (AB_beta>AC_beta) {
    swap(AB_beta,AC_beta);
    swap(AB_gamma,AC_gamma);
  }
  //::: (*) check if AC hits within triangle T
  if ((AC_gamma>=0)&&(AC_beta+AC_gamma<=1)) return 1;	// yes; we know AC_beta>=0

  if (AB_beta<0) {	// know AB hits in quad II or III and AC hits in quad I or IV
    // neither hitpoint within triangle T, so check if line between hitpoints is
    // (*) find where line hits gamma-axis
    rPoint3 dum=rPoint3(AB_beta,AB_gamma,1.0).Cross(rPoint3(AC_beta,AC_gamma,1.0));
    rPoint3 hit=rPoint3(1,0,0).Cross(dum);
    hit.y/=hit.z;
    if (hit.y<=0) {
      // check if hitpoint for AC is in quad I
      if (AC_gamma<=0) return 0;	// line seg hits below beta axis (in quad IV)
      // check where seg crosses beta axis (done later)
    }
    else if (hit.y<=1) return 1;	// line seg hits left-hand wall of T
    else if (AC_gamma>=0) return 0;	// so can't hit T since AC hits in quad I
    // (*) last chance: must hit bottom wall of T (so intersect with beta-axis)
    hit=rPoint3(0,1,0).Cross(dum);
    hit.x/=hit.z;
    return ((hit.x>=0.0)&&(hit.x<=1.0));
  }
  else {		// know both hitpoints are in quads I or IV
    if (AB_beta>=1.0) return 0;	// both hitpoints right of line beta=1
    //::: test if AB hits in triangle T
    if ((AB_gamma>=0)&&(AB_beta+AB_gamma<=1)) return 1;	// yes it does
    // ...else neither hitpoint within triangle T, so check if line between hitpoints is
    // check if both hitpoints in quad I (but neither in T)
    if ((AB_gamma>=0)&&(AC_gamma>=0)) return 0;
    // one hitpoint in quad I other in quad IV; see where between hits beta axis
    rPoint3 dum=rPoint3(AB_beta,AB_gamma,1.0).Cross(rPoint3(AC_beta,AC_gamma,1.0));
    rPoint3 hit=rPoint3(0,1,0).Cross(dum);
    hit.x/=hit.z;
    return (hit.x<=1);
  }
}

//////////////////////////////////////////////////////////////////////
void IntersectionOf3Triangles(
  boole&			b_intersect,		// do the tris intersect?
  rPoint3&			P,			// intersection point
  const ClusterTriangle&	A,
  const ClusterTriangle&	B,
  const ClusterTriangle&	C
)
{
  // NORMa*(x-a) = 0 iff x is in plane of triangle a
  rPoint3 na=((A.b-A.a).Cross(A.c-A.a)).Hat();
  rPoint3 nb=((B.b-B.a).Cross(B.c-B.a)).Hat();
  rPoint3 nc=((C.b-C.a).Cross(C.c-C.a)).Hat();
  real dpa=-(na.Dot(A.a));
  real dpb=-(nb.Dot(B.a));
  real dpc=-(nc.Dot(C.a));
  rMatrix M(3,4);
  M[0][0]=na.x;    M[0][1]=na.y;    M[0][2]=na.z;    M[0][3]=dpa;
  M[1][0]=nb.x;    M[1][1]=nb.y;    M[1][2]=nb.z;    M[1][3]=dpb;
  M[2][0]=nc.x;    M[2][1]=nc.y;    M[2][2]=nc.z;    M[2][3]=dpc;
  rVector v;
  M.FindNullEigenvector(v);
  P=rPoint3(v[0],v[1],v[2]);
  P/=v[3];

  //::: put P in triangle-based coords and check if P really is inside triangle
  Transform T_triA_world(A.b-A.a,A.c-A.a,na);
  Transform T_world_triA=T_triA_world.Inverse();
  rPoint3 P_triA=T_world_triA*(P-A.a);

  Transform T_triB_world(B.b-B.a,B.c-B.a,nb);
  Transform T_world_triB=T_triB_world.Inverse();
  rPoint3 P_triB=T_world_triB*(P-B.a);

  Transform T_triC_world(C.b-C.a,C.c-C.a,nc);
  Transform T_world_triC=T_triC_world.Inverse();
  rPoint3 P_triC=T_world_triC*(P-C.a);

  b_intersect=
    ( ((P_triA.x>=0)&&(P_triA.y>=0)&&(P_triA.x+P_triA.y<=1))&&
      ((P_triB.x>=0)&&(P_triB.y>=0)&&(P_triB.x+P_triB.y<=1))&&
      ((P_triC.x>=0)&&(P_triC.y>=0)&&(P_triC.x+P_triC.y<=1)) );
}

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
void IntersectionByTriangles::PerformIntersectionByTriangles(
  LinkedList<rPoint3>&		ll_mutuals,
  const Array<int>&		draws,
  const Array<LinkedList_ClusterLatticeCluster>&	ll_clusters,
  const boole			CON_b_show_stats
)
{
  const int ONE=draws[0], TWO=draws[1], THREE=draws[2];

  //::: exhaustively compare each cluster bounding box for two manifolds
  SCREENPUT if (CON_b_show_stats) { BANNER("intersecting bounding boxes");  fflush(stdout); }
  LinkedList<ClusterPair> ll_overlap;
  FORLIST(ll_clusters[ONE]) {
    ClusterLatticeCluster& Ca=ll_clusters[ONE].Now();
    if (!Ca.b_legal) continue;
    FORLIST(ll_clusters[TWO]) {
      ClusterLatticeCluster& Cb=ll_clusters[TWO].Now();
      if (!Cb.b_legal) continue;
      if (Ca.lo.x>Cb.hi.x) continue;
      if (Cb.lo.x>Ca.hi.x) continue;
      if (Ca.lo.y>Cb.hi.y) continue;
      if (Cb.lo.y>Ca.hi.y) continue;
      if (Ca.lo.z>Cb.hi.z) continue;
      if (Cb.lo.z>Ca.hi.z) continue;
      //::: boxes overlap
      ClusterPair* pair=new ClusterPair;
      pair->a=&Ca;
      pair->b=&Cb;
      ll_overlap.Add(pair);
    }
  }

/*
  //::: show boxes that are part of an overlap pair
  //::: (*) mark all boxes as illegal
  FORi(2) {
    FORLISTnow(ll_clusters[i], ClusterLatticeCluster*)
      now->b_legal=FALSE;
    }
  }

  //::: (*) mark as legal only those boxes that overlap another
  FORLISTnow(ll_overlap, ClusterPair)
    now.a->b_legal=TRUE;
    now.b->b_legal=TRUE;
  }

  //::: (*) display bounding boxes
  SCREENPUT BANNER("displaying bounding boxes");
  VrmlFile::Open("bounding.boxes.wrl");
  FORi(2) {
    FORLISTnow(ll_clusters[i], ClusterLatticeCluster*)
      if (!now->b_legal) continue;
      VrmlFile::OutputBox(now->lo,now->hi,color[i]);
    }
  }
  VrmlFile::Close();
*/

  if (CON_b_show_stats) SCREENPUT { printf("OVERLAP PAIRS:  %d\n",ll_overlap.size);  fflush(stdout); }

  //::: for each overlapping cluster pair, exhaustively check pairwise triangle intersections
  SCREENPUT if (CON_b_show_stats) { BANNER("checking pairwise triangle intersection for overlapping clusters");  fflush(stdout); }
  long n_test_count=0;
  LinkedList<ClusterTrianglePair> ll_inters;	// stores each pair of intersecting triangles
  FORLISTnow(ll_overlap, ClusterPair)
    //::: create list of triangles for each cluster
    FORl(2) {
      const int i=(l==0) ? ONE : TWO;
      ClusterLatticeCluster* pcl=(l==0) ? now.a : now.b;
      ClusterLatticeCluster& cl=*pcl;
      if (cl.b_tri_exist) continue;		// only realize triangles if haven't previously done so
      // make into function; used another place, too
      cl.b_tri_exist=TRUE;
      int th0=cl.th0;
      int th1=cl.th1-1;
      int ka0=cl.ka0;
      int ka1=cl.ka1-1;
      FORjIN(th0,th1) FORkIN(ka0,ka1) {
        //::: only allow reasonably small triangles with legal vertices
        if (!b_lattice[i][j+1][k]) continue;
        if (!b_lattice[i][j][k+1]) continue;
        const rPoint3& b=lattice[i][j+1][k];
        const rPoint3& c=lattice[i][j][k+1];
        real d3=(b-c).Norm();
        if (d3>=0.1) continue;
        if (b_lattice[i][j][k]) {
          const rPoint3& a=lattice[i][j][k];
          real d1=(a-b).Norm();
          real d2=(a-c).Norm();
          if ((d1<.1)||(d2<.1))
            cl.tri.Add(new ClusterTriangle(a,b,c));
        }
        if (b_lattice[i][j+1][k+1]) {
          const rPoint3& a=lattice[i][j+1][k+1];
          real d1=(a-b).Norm();
          real d2=(a-c).Norm();
          if ((d1<.1)||(d2<.1))
            cl.tri.Add(new ClusterTriangle(a,b,c));
        }
      
/*
        if (!b_lattice[i][j+1][k]) continue;
        if (!b_lattice[i][j][k+1]) continue;
        if (b_lattice[i][j][k])
          cl.tri.Add(new ClusterTriangle(lattice[i][j][k],     lattice[i][j+1][k], lattice[i][j][k+1]));
        if (b_lattice[i][j+1][k+1])
          cl.tri.Add(new ClusterTriangle(lattice[i][j+1][k+1], lattice[i][j+1][k], lattice[i][j][k+1]));
*/
      }
    }
    //::: try to intersect each triangle pair
    const LinkedList<ClusterTriangle>& tri0=now.a->tri;
    const LinkedList<ClusterTriangle>& tri1=now.b->tri;
    FORLIST(tri0) {
      ClusterTriangle& A=tri0.Now();
      FORLIST(tri1) {
        ClusterTriangle& B=tri1.Now();
        boole b_inters=tri_tri_intersect(A,B);
        if (b_inters) {
          ClusterTrianglePair* pair=new ClusterTrianglePair;
          pair->a=A;
          pair->b=B;
          pair->lo=A.a;
          if (pair->lo.x>A.b.x) pair->lo.x=A.b.x;
          if (pair->lo.x>A.c.x) pair->lo.x=A.c.x;
          if (pair->lo.x>B.a.x) pair->lo.x=B.a.x;
          if (pair->lo.x>B.b.x) pair->lo.x=B.b.x;
          if (pair->lo.x>B.c.x) pair->lo.x=B.c.x;
          if (pair->lo.y>A.b.y) pair->lo.y=A.b.y;
          if (pair->lo.y>A.c.y) pair->lo.y=A.c.y;
          if (pair->lo.y>B.a.y) pair->lo.y=B.a.y;
          if (pair->lo.y>B.b.y) pair->lo.y=B.b.y;
          if (pair->lo.y>B.c.y) pair->lo.y=B.c.y;
          if (pair->lo.z>A.b.z) pair->lo.z=A.b.z;
          if (pair->lo.z>A.c.z) pair->lo.z=A.c.z;
          if (pair->lo.z>B.a.z) pair->lo.z=B.a.z;
          if (pair->lo.z>B.b.z) pair->lo.z=B.b.z;
          if (pair->lo.z>B.c.z) pair->lo.z=B.c.z;
      
          pair->hi=A.a;
          if (pair->hi.x<A.b.x) pair->hi.x=A.b.x;
          if (pair->hi.x<A.c.x) pair->hi.x=A.c.x;
          if (pair->hi.x<B.a.x) pair->hi.x=B.a.x;
          if (pair->hi.x<B.b.x) pair->hi.x=B.b.x;
          if (pair->hi.x<B.c.x) pair->hi.x=B.c.x;
          if (pair->hi.y<A.b.y) pair->hi.y=A.b.y;
          if (pair->hi.y<A.c.y) pair->hi.y=A.c.y;
          if (pair->hi.y<B.a.y) pair->hi.y=B.a.y;
          if (pair->hi.y<B.b.y) pair->hi.y=B.b.y;
          if (pair->hi.y<B.c.y) pair->hi.y=B.c.y;
          if (pair->hi.z<A.b.z) pair->hi.z=A.b.z;
          if (pair->hi.z<A.c.z) pair->hi.z=A.c.z;
          if (pair->hi.z<B.a.z) pair->hi.z=B.a.z;
          if (pair->hi.z<B.b.z) pair->hi.z=B.b.z;
          if (pair->hi.z<B.c.z) pair->hi.z=B.c.z;
      
          ll_inters.Add(pair);
        }
        ++n_test_count;
      }
    }
  }
  SCREENPUT if (CON_b_show_stats) { printf("TOTAL TRI INTERSECTION TESTS:  %ld\n",n_test_count);  fflush(stdout); }
  SCREENPUT if (CON_b_show_stats) { printf("TOTAL PAIRWISE TRI INTERSECTIONS:  %ld\n",ll_inters.size);  fflush(stdout); }

  //::: free unneeded memory
  // ll_inters must be freed at end of each RANSAC trial!!!!!!!!

/*
  //::: display pairwise intersections
  LinkedList<rPoint3> ll_TRI_a;
  FORLISTnow(ll_inters, ClusterTrianglePair)
    ll_TRI_a.Add(new rPoint3(now.a.a));
    ll_TRI_a.Add(new rPoint3(now.a.b));
    ll_TRI_a.Add(new rPoint3(now.a.b));
    ll_TRI_a.Add(new rPoint3(now.a.c));
    ll_TRI_a.Add(new rPoint3(now.a.c));
    ll_TRI_a.Add(new rPoint3(now.a.a));
  }
  LinkedList<rPoint3> ll_TRI_b;
  FORLISTnow(ll_inters, ClusterTrianglePair)
    ll_TRI_b.Add(new rPoint3(now.b.a));
    ll_TRI_b.Add(new rPoint3(now.b.b));
    ll_TRI_b.Add(new rPoint3(now.b.b));
    ll_TRI_b.Add(new rPoint3(now.b.c));
    ll_TRI_b.Add(new rPoint3(now.b.c));
    ll_TRI_b.Add(new rPoint3(now.b.a));
  }
  VrmlFile::Open("pairwise.intersecting.triangles.wrl");
  Array<rPoint3> M;
  M=ll_TRI_a;	ll_TRI_a.FreeMem();
  VrmlFile::OutputLines(M,color[0]);
  M=ll_TRI_b;	ll_TRI_b.FreeMem();
  VrmlFile::OutputLines(M,color[1]);
  VrmlFile::Close();
  M.FreeMem();
  EXIT();
*/

  //::: now intersect overlapping triangles with third manifold
  //::: (*) compare bb of each cluster in third manifold with bb of each triangle pair
  //::: (*) if bb's overlap, compare each triangle within cluster with triangle pair
  LinkedList<ClusterTriangleTriplet> ll_mutual_inters;		// possible triples stored here
  FORLIST(ll_clusters[THREE]) {
    CONST ClusterLatticeCluster& cl=ll_clusters[THREE].Now();
    if (!cl.b_legal) continue;
    FORLISTnow(ll_inters, ClusterTrianglePair)
      // compare bounding boxes
      if (cl.lo.x>now.hi.x) continue;
      if (now.lo.x>cl.hi.x) continue;
      if (cl.lo.y>now.hi.y) continue;
      if (now.lo.y>cl.hi.y) continue;
      if (cl.lo.z>now.hi.z) continue;
      if (now.lo.z>cl.hi.z) continue;
      
      // check each triangle in cluster C vs. pair
      if (!cl.b_tri_exist) {
      
        // make into function; used another place, too
        cl.b_tri_exist=TRUE;
        int th0=cl.th0;
        int th1=cl.th1-1;
        int ka0=cl.ka0;
        int ka1=cl.ka1-1;
        FORjIN(th0,th1) FORkIN(ka0,ka1) {
          //::: only allow reasonably small triangles with legal vertices
          if (!b_lattice[THREE][j+1][k]) continue;
          if (!b_lattice[THREE][j][k+1]) continue;
          const rPoint3& b=lattice[THREE][j+1][k];
          const rPoint3& c=lattice[THREE][j][k+1];
          real d3=(b-c).Norm();
          if (d3>=0.1) continue;
          if (b_lattice[THREE][j][k]) {
            const rPoint3& a=lattice[THREE][j][k];
            real d1=(a-b).Norm();
            real d2=(a-c).Norm();
            if ((d1<.1)||(d2<.1))
              cl.tri.Add(new ClusterTriangle(a,b,c));
          }
          if (b_lattice[THREE][j+1][k+1]) {
            const rPoint3& a=lattice[THREE][j+1][k+1];
            real d1=(a-b).Norm();
            real d2=(a-c).Norm();
            if ((d1<.1)||(d2<.1))
              cl.tri.Add(new ClusterTriangle(a,b,c));
          }
        }
      
      }
      FORLIST(cl.tri) {
        CONST ClusterTriangle& C=cl.tri.Now();
        CONST ClusterTriangle& A=now.a;
        CONST ClusterTriangle& B=now.b;
        boole b_inters_AC=tri_tri_intersect(A,C);
        boole b_inters_BC=tri_tri_intersect(B,C);
        if (b_inters_AC && b_inters_BC) {
          ClusterTriangleTriplet* trip=new ClusterTriangleTriplet;
          trip->a=A;
          trip->b=B;
          trip->c=C;
          ll_mutual_inters.Add(trip);
        }
      }
    }
  }
  SCREENPUT if (CON_b_show_stats) { printf("POSSIBLE THREEWAY INTERSECTIONS:  %ld\n",ll_mutual_inters.size);  fflush(stdout); }

  //::: find exact mutual intersection points for triples that seem to intersect
  FORLISTnow(ll_mutual_inters, ClusterTriangleTriplet)
    rPoint3 P;
    boole b_intersect;
    IntersectionOf3Triangles(b_intersect,P,now.a,now.b,now.c);
    if (b_intersect) ll_mutuals.Add(new rPoint3(P));
  }
  SCREENPUT if (CON_b_show_stats) { printf("TOTAL TRUE THREEWAY INTERSECTIONS:  %ld\n",ll_mutuals.size);  fflush(stdout); }

/*
  //::: display threeway intersections
  LinkedList<rPoint3> ll_TRI_a;
  FORLISTnow(ll_mutual_inters, ClusterTriangleTriplet)
    ll_TRI_a.Add(new rPoint3(now.a.a));
    ll_TRI_a.Add(new rPoint3(now.a.b));
    ll_TRI_a.Add(new rPoint3(now.a.b));
    ll_TRI_a.Add(new rPoint3(now.a.c));
    ll_TRI_a.Add(new rPoint3(now.a.c));
    ll_TRI_a.Add(new rPoint3(now.a.a));
  }
  LinkedList<rPoint3> ll_TRI_b;
  FORLISTnow(ll_mutual_inters, ClusterTriangleTriplet)
    ll_TRI_b.Add(new rPoint3(now.b.a));
    ll_TRI_b.Add(new rPoint3(now.b.b));
    ll_TRI_b.Add(new rPoint3(now.b.b));
    ll_TRI_b.Add(new rPoint3(now.b.c));
    ll_TRI_b.Add(new rPoint3(now.b.c));
    ll_TRI_b.Add(new rPoint3(now.b.a));
  }
  LinkedList<rPoint3> ll_TRI_c;
  FORLISTnow(ll_mutual_inters, ClusterTriangleTriplet)
    ll_TRI_c.Add(new rPoint3(now.c.a));
    ll_TRI_c.Add(new rPoint3(now.c.b));
    ll_TRI_c.Add(new rPoint3(now.c.b));
    ll_TRI_c.Add(new rPoint3(now.c.c));
    ll_TRI_c.Add(new rPoint3(now.c.c));
    ll_TRI_c.Add(new rPoint3(now.c.a));
  }
  VrmlFile::Open("threeway.intersecting.triangles.wrl");
  Array<rPoint3> M;
  M=ll_TRI_a;	ll_TRI_a.FreeMem();
  VrmlFile::OutputLines(M,color[0]);
  M=ll_TRI_b;	ll_TRI_b.FreeMem();
  VrmlFile::OutputLines(M,color[1]);
  M=ll_TRI_c;	ll_TRI_c.FreeMem();
  VrmlFile::OutputLines(M,color[2]);
  //::: show true intersection point
  M.SetSize(1);
  M[0]=true_alpha;
  VrmlFile::OutputPoints(M,RGB3Byte_yellow,15);
  //::: show calc'd mutual intersection points
  M=ll_mutuals;
  VrmlFile::OutputPoints(M,RGB3Byte_pink,16);
  VrmlFile::Close();
  M.FreeMem();
*/

  //::: free mem
  ll_inters.FreeMem();
  ll_overlap.FreeMem();
  ll_mutual_inters.FreeMem();
}
