#ifndef INCLUDED_MeshGenerationRoutines
#define INCLUDED_MeshGenerationRoutines

//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

#include "IntersectionByTriangles.h"

//////////////////////////////////////////////////////////////////////
void NormalizeVotingSpace(
  Array2D<real>&		Theta,
  Array2D<real>&		Kappa,
  Array<Array2D_rPoint3>&	lattice,
  Array<Array2D_boole>&		b_lattice
);

//////////////////////////////////////////////////////////////////////
void SetLattice(
  Array2D<real>&		Theta,
  Array2D<real>&		Kappa,
  Array<Array2D_rPoint3>&	lattice,
  Array<Array2D_boole>&		b_lattice,

  const Array<real>&		min_th,
  const Array<real>&		max_th,
  const Array<real>&		min_ka,
  const Array<real>&		max_ka,
  const int			CON_n_theta,
  const int			CON_n_kappa,
  const int			CON_n_mani,

  const Array<ViewPairInfo>&	pairinfo,
  const Array<Transform>&	T0i_proj,
  const Array<rPoint3>&		E
);

//////////////////////////////////////////////////////////////////////
void CreateTriangleClusters(
  Array<LinkedList_ClusterLatticeCluster>&	ll_clusters,
  const Array<Array2D_rPoint3>&			lattice,
  const Array<Array2D_boole>&			b_lattice,
  const int					CON_n_kappa,
  const int					CON_n_theta,
  const int					CON_ka_step,
  const int					CON_th_step
);

///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////

#endif
