#ifndef INCLUDED_PlotManifolds
#define INCLUDED_PlotManifolds

///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////

#include "Array.h"
#include "Array2D.h"
#include "Transform.h"
#include "ManifoldPointStruct.3Space.h"

///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////
void PlotPointsOnModulusConstraintManifold(
  const Array<Transform>&	F,
  const Array<Transform>&	M,
  const Array<rPoint3>&		eB,
  const AlphaCoord&		true_alpha
);

///////////////////////////////////////////////////////////////////////
void PPOMCM_FindAlpha(
  AlphaCoord&			alpha,
  const Transform&		Tij_met,
  const Array<Transform>&	T0i_proj,
  const Array<rPoint3>&		E,
  const int			i,
  const int			j
);

///////////////////////////////////////////////////////////////////////
void PlotPointsOnModulusConstraintManifold(
  const Array<Transform>&	T0i,	//relative transforms in chosen projective space
  const Array<rPoint3>&		E,
  const Array2D<Transform>&	F,
  const Array2D<Transform>&	M,
  const Array2D<rPoint3>&	eB,
  const int			CON_nmanifolds_to_plot
);

///////////////////////////////////////////////////////////////////////
void ShowManifoldFixedTheta(
  const Array2D<Transform>&	F,
  const Array2D<Transform>&	M,
  const Array2D<rPoint3>&	eB,
  const AlphaCoord&		true_alpha,

  const Array<Transform>&	T0i_proj,
  const Array<rPoint3>&		E,
  const int			one,
  const int			two
);

///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////

#endif
