#include "TestRunDataStruct.h"

///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////

boole GLOBAL_writescreenon=FALSE;
TestRunDataStruct GLOBAL_testrun_data;

///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////
void TestRunDataStruct::Write(FILE* file)
{
  fprintf(file,"%2d %13.6e %13.6e %13.6e %3d %4d %13.6e %13.6e %13.6e %13.6e %13.6e %13.6e %13.6e %3d %3d %8d %2d %2d %2d %4d\n",
    error_code,
    min_retinal_obj_size,
    noise_radius,
    actual_noise_per_pixel,
    n_views,
    n_scene_points,
    error_frobenius_main,
    error_frobenius,
    error_per_entry[0][0],
    error_per_entry[0][1],
    error_per_entry[0][2],
    error_per_entry[1][1],
    error_per_entry[1][2],
    n_zoomins,
    n_manifolds_at_end,
    n_total_manifold_points_generated,
    n_votes_to_zoomin,
    n_vote_voxels_per_side,
    n_bacteria_voxels_per_side,
    min_flesh_out_level
  );
}

///////////////////////////////////////////////////////////////////////
void TestRunDataStruct::Clear()
{
  error_code=0;
  min_retinal_obj_size=0;
  noise_radius=0;
  actual_noise_per_pixel=0;
  n_views=0;
  n_scene_points=0;
  error_frobenius_main=0;
  error_frobenius=0;
  error_per_entry=Transform(0,0,0,0,0,0,0,0,0);
  n_zoomins=0;
  n_manifolds_at_end=0;
  n_total_manifold_points_generated=0;
  n_votes_to_zoomin=0;
  n_vote_voxels_per_side=0;
  n_bacteria_voxels_per_side=0;
  min_flesh_out_level=0;
  n_grid_size_ka=0;
  n_grid_size_th=0;
  n_ransac_trials=0;
}

///////////////////////////////////////////////////////////////////////
void TestRunDataStruct::Write_TriangleIntersect_TR1428(FILE* file)
{
  fprintf(file,"%2d %13.6e %13.6e %13.6e %3d "
               "%4d %13.6e %13.6e %13.6e %13.6e "
               "%13.6e %13.6e %13.6e %4d %4d "
               "%4d %13.6e %13.6e %3d %3d\n",

    error_code,
    min_retinal_obj_size,
    noise_radius,
    actual_noise_per_pixel,
    n_views,

    n_scene_points,
    error_frobenius_main,
    error_frobenius,
    error_per_entry[0][0],
    error_per_entry[0][1],

    error_per_entry[0][2],
    error_per_entry[1][1],
    error_per_entry[1][2],
    n_grid_size_ka,
    n_grid_size_th,

    n_ransac_trials,
    time_lattice_pt,
    time_all_ransac,
    n_grid_block_size_ka,
    n_grid_block_size_th

  );
}

///////////////////////////////////////////////////////////////////////
void TestRunDataStruct::Write_TriangleIntersect_Iteration_TR1428(FILE* file)
{
  fprintf(file,"%3d %3d %13.6e %13.6e %13.6e "
               "%13.6e %13.6e %13.6e\n",
    iter_n_intersection_pts,
    min(iter_n_intersection_pts,int16(10)),		// this makes graph plotting in matlab more convenient
    iter_best_frob_error,
    iter_time_iteration,
    iter_1st_ransac_error,
    iter_2nd_ransac_error,
    iter_1st_frob_error,
    iter_2nd_frob_error
  );
}

///////////////////////////////////////////////////////////////////////
void TestRunDataStruct::WriteComment(FILE* file, char* s)
{
  fprintf(file,"\%\% %s\n",s);
}
