#ifndef INCLUDED_TestRunDataStruct
#define INCLUDED_TestRunDataStruct

///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////

#include <stdio.h>

#include "ManifoldPointStruct.3Space.h"

///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////

extern boole GLOBAL_writescreenon;
#define SCREENPUT if (GLOBAL_writescreenon) 

struct TestRunDataStruct {

  //::: raw data sent to run
  real			min_retinal_obj_size;
  real			noise_radius;
  real			actual_noise_per_pixel;
  int16			n_views;
  int16			n_scene_points;
  
  //::: performance of the run
  int8			error_code;		// 0=good; -1=failure
  real			error_frobenius;	// ignores error in principle pt
  real			error_frobenius_main;	// full Frobenius error (mislabeled)
  Transform		error_per_entry;	// error for each entry in K (the meaning changed)
  int16			n_zoomins;
  int16			n_manifolds_at_end;
  int32			n_total_manifold_points_generated;
  real			time_lattice_pt;
  real			time_all_ransac;

  //::: per ransac iteration results
  int16			iter_n_intersection_pts;
  real			iter_best_frob_error;
  real			iter_time_iteration;
  real			iter_1st_ransac_error;
  real			iter_2nd_ransac_error;
  real			iter_1st_frob_error;
  real			iter_2nd_frob_error;

  //::: run parameters
  uint8			n_votes_to_zoomin;
  uint8			n_vote_voxels_per_side;
  uint8			n_bacteria_voxels_per_side;
  int16			min_flesh_out_level;
  int16			n_grid_size_ka;
  int16			n_grid_size_th;
  int16			n_grid_block_size_ka;
  int16			n_grid_block_size_th;
  int16			n_ransac_trials;
  
  //::: file handles
  FILE*			file_per_iteration_data;

  void Clear();
  void Write(FILE*);
  void Write_TriangleIntersect_TR1428(FILE*);
  void Write_TriangleIntersect_Iteration_TR1428(FILE*);
  void WriteComment(FILE*, char* s);
};

extern TestRunDataStruct GLOBAL_testrun_data;

///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////

#endif
